package com.qizhen.healsphere.common.ai;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.fastjson.JSONObject;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class DeepSeekUtil {
    private static String apiUrl = "https://api.lkeap.cloud.tencent.com/v1/chat/completions";

    public static String getChatResponse(String userInput) {
        int retry = 0;
        try {
            return getAnswer(userInput);
        }catch(Exception e){
            e.printStackTrace();
            retry++;
            if(retry>=2){
               return "";
            }
            return getAnswer(userInput);
        }

    }

    private static String getAnswer(String userInput) {
        // 构建请求体
        Map<String, Object> requestBody = new HashMap<>();

        requestBody.put("model", "deepseek-v3");
        requestBody.put("stream", false);
        //requestBody.put("model", "deepseek-r1");
        //requestBody.put("model", "ernie-3.5-8k");

        //app-VUPQ3Rq1
        Map messages = new HashMap();
        messages.put("role","user");
        messages.put("content",userInput);
        requestBody.put("messages", new Object[]{messages});
        String requestBodyJson = JSONObject.toJSONString(requestBody);
        System.out.println(requestBodyJson);
        HttpRequest request = HttpUtil.createRequest(Method.POST, apiUrl)
                .header("Content-Type", "application/json")
                .header("Authorization", "Bearer sk-vxnoy9XGv0xG3qZ2XfuMlKzY6eKB9XST1nTSn5PQJxDLKDjY")
                .body(requestBodyJson).timeout(60*1000);
        ;
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        System.out.println("耗时:"+(System.currentTimeMillis()-l));
        System.out.println(resposne);
        String result = JSONObject.parseObject(resposne).getJSONArray("choices").getJSONObject(0).getJSONObject("message").getString("content");
        return result==null?"":result;
    }



    public static void main(String[] args) {

        // 定义提示文本
        String propmt = "## 角色定位\n" +
                "- 专业医疗NLP信息抽取助手，专注从患者主诉/现病史文本中精准提取标准化症状术语\n" +
                "\n" +
                "## 核心能力\n" +
                "1. 医学语义理解：\n" +
                "   - 精准解析临床表现描述\n" +
                "   - 将口语化表达转换为ICD-11标准术语\n" +
                "   - 完整提取症状特征（性质/部位/放射等），保持症状描述的临床完整性\n" +
                "\n" +
                "2. 专业能力：\n" +
                "   - 精通ICD-11症状学术语体系\n" +
                "   - 识别症状关联性\n" +
                "   - 具备临床鉴别诊断思维\n" +
                "\n" +
                "## 输出要求\n" +
                "- 仅输出JSON格式结果，禁止添加解释性文字\n" +
                "- 非症状不要抽取\n" +
                " - 症状术语必须标准化\n" +
                "- 尽量保留原始症状的临床特征（如部位、性质、放射等）\n" +
                "- 抽取的症状应该简洁明了，尽量保持在5个字符以内，最多不宜超过7个字符。如果超过可以分多个症状词进行抽取。\n" +
                "\n" +
                "## 处理流程\n" +
                "1. 接收患者主诉文本\n" +
                "2. 识别并提取所有症状描述\n" +
                "3. 转换为ICD-11标准术语\n" +
                "4. 结构化输出症状列表\n" +
                "\n" +
                "示例1：\n" +
                "\n" +
                "输入：突然感觉胸口压榨样疼痛，持续不缓解，向左肩和下颌放射，伴大汗、恶心，已经30分钟了。\n" +
                "\n" +
                "输出： { \"symptoms\": [\"胸痛\", \"左肩放射痛\", \"下颌放射痛\",\"大汗\",\"恶心\"] }\n此次用户输入：\n";
        String des = "主诉：右上腹痛绞痛2小时\n现病史：2小时前无诱因下出现持续性右上腹部绞痛，剧痛难忍，伴恶心，发热，黄疸；无呕吐，无大小便异常。";
        System.out.println(DeepSeekUtil.getChatResponse(propmt + des));
    }



}
