package com.qizhen.healsphere.common.ai;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class QizhenAssistant {

    public static String noAnswer = "未找到相关知识";

    public static Map<String, String> getChatResponse(String userInput, String conversationId, String appId, boolean tuili) {
        int retry = 0;
        try {
            return getAnswer(userInput, conversationId, appId, tuili);
        } catch (Exception e) {
            retry++;
            if (retry >= 20) {
                Map<String, String> map = new HashMap<>();
                map.put("answer", "failed");
                return map;
            }
            return getAnswer(userInput, conversationId, appId, tuili);

        }
    }

    public static Map<String, String> getChatResponse(String userInput, String conversationId, String appId) {
        return getChatResponse(userInput, conversationId, appId, false);
    }

    public static final String domain = "https://console.bce.baidu.com/ai_apaas/personalSpace/knowledgeBase/document/detail/";

    private static boolean contants(String content, String regex) {
        // 编译正则表达式
        Pattern pattern = Pattern.compile(regex);

        // 创建matcher对象
        Matcher matcher = pattern.matcher(content);
        return matcher.find();
    }

    private static Map<String, String> getAnswer(String userInput, String conversationId, String appId, boolean tuili) {
        String resposne = call(appId, conversationId, userInput);
        Map<String, String> map = new HashMap<>();
        String answer = JSONObject.parseObject(resposne).getString("answer");
        if (answer.contains(noAnswer)) {
            map.put("answer", noAnswer);
            return map;
        }
        map.put("answer", answer == null ? noAnswer : answer);
        JSONArray contents = JSONObject.parseObject(resposne).getJSONArray("content");
        JSONArray docs = new JSONArray();
        List<String> defaultReferences = new ArrayList<>();
        for (int i = 0; i < contents.size(); i++) {
            JSONObject content = contents.getJSONObject(i);
            if ("rag".equals(content.getString("content_type"))) {
                JSONObject outputs = content.getJSONObject("outputs");
                if (outputs != null) {
                    JSONArray references = outputs.getJSONArray("references");
                    if (references != null && references.size() > 0) {
                        for (int j = 0; j < references.size(); j++) {
                            JSONObject reference = new JSONObject();
                            String id = references.getJSONObject(j).getString("id");
                            if (!contants(answer, "\\^(\\[\\d+\\])*\\[" + id + "\\](\\[\\d+\\])*\\^")) {
                                continue;
                            }
                            reference.put("index", id);
                            //reference.put("url", domain + references.getJSONObject(j).getString("knowledgebase_id") + "/" + references.getJSONObject(j).getString("document_id"));
                            reference.put("content", references.getJSONObject(j).getString("content"));
                            String title = references.getJSONObject(j).getString("title");
                            reference.put("title", title);
                            //reference.put("chunk_id", references.getJSONObject(j).getString("chunk_id"));
                            docs.add(reference);
                            defaultReferences.add(title);
                        }
                    }
                }
            }
        }

        boolean notMatch = (docs == null || docs.size() == 0);
        if (!tuili) {//不允许推理
            if(notMatch) {
                map.put("answer", noAnswer);
                return map;
            }
            map.put("references", docs.toJSONString());
            map.put("defaultReferences", JSON.toJSONString(defaultReferences));
        }else  if(!notMatch) {
            map.put("references", docs.toJSONString());
        }else{
            map.put("references", "[]");
        }

        return map;
    }

    public static String getConversationId(String appId) {
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        //json.put("app_id", "454b1634-91ad-4dde-9d2f-f9a3302fdcbe");
        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation")
                .header("Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString());
        ;
        String resposne = request.execute().body();
        return JSONObject.parseObject(resposne).getString("conversation_id");
    }

    public static String call(String appId, String conversationId, String userInput){
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        json.put("conversation_id", conversationId);
        json.put("query", userInput);
        json.put("stream", false);


        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation/runs")
                .header("Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString()).timeout(120 * 1000);
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        System.out.println(userInput.length());
        long ct = (System.currentTimeMillis() - l) / 1000;
        System.out.println(ct);
        System.out.println(userInput.length()/ct);
        System.out.println("===========================");
        return resposne;
    }

    public static void main(String[] args) {
        JSONObject json = new JSONObject();
        json.put("text", "{\n" +
                "  \"hospitalId\": -1,\n" +
                "  \"age\": \"28\",\n" +
                "  \"sex\": 2,\n" +
                "  \"doctor\": {\n" +
                "    \"professionalTitle\": \"付医生\"\n" +
                "  },\n" +
                "  \"chief\": \"上腹痛绞痛2小时\",\n" +
                "  \"symptom\": \"2小时前无诱因下出现持续性上腹部绞痛，剧痛难忍，伴恶心慢性，无呕吐，无大小便异常，曾至当地卫生院就诊，查血常规提示：血小板计数5*10^9/L\",\n" +
                "  \"vital\": \"神清，急性病容，皮肤巩膜黄软，心肺无殊，腹平软，上腹部压痛明显，无反跳痛\",\n" +
                "  \"pasts\": \"既往有胆总管结石，既往青霉素过敏\",\n" +
                "  \"marriage\": \"\",\n" +
                "  \"personal\": \"不饮酒，不抽烟\",\n" +
                "  \"family\": \"不详\",\n" +
                "  \"marital\": \"未婚未育\",\n" +
                "  \"menstrual\": \"末次月经2020-12-23，月经期第二天\",\n" +
                "  \"diseaseName\": {\n" +
                "    \"dateValue\": \"\",\n" +
                "    \"name\": \"胆囊结石伴有急性胆囊炎\",\n" +
                "    \"uniqueName\": \"\"\n" +
                "  },\n" +
                "  \"otherIndex\": {},\n" +
                "  \"operationName\": {\n" +
                "    \"dateValue\": \"2020-12-24 17:39:20\",\n" +
                "    \"name\": \"经皮肝穿刺引流术\",\n" +
                "    \"uniqueName\": \"经皮肝穿刺引流术\"\n" +
                "  },\n" +
                "  \"infectious\": \"\",\n" +
                "  \"operation\": [],\n" +
                "  \"allergy\": \"\",\n" +
                "  \"vaccination\": \"\",\n" +
                "  \"other\": \"\",\n" +
                "  \"lisString\": \"\",\n" +
                "  \"pacsString\": \"\",\n" +
                "  \"diagString\": \"\",\n" +
                "  \"drugString\": \"\",\n" +
                "  \"lis\": [],\n" +
                "  \"pacs\": [],\n" +
                "  \"diag\": [\n" +
                "    {\n" +
                "      \"dateValue\": \"\",\n" +
                "      \"name\": \"胆囊结石伴有急性胆囊炎\",\n" +
                "      \"uniqueName\": \"\"\n" +
                "    }\n" +
                "  ],\n" +
                "  \"lisOrder\": [],\n" +
                "  \"pacsOrder\": [\n" +
                "    {\n" +
                "      \"uniqueName\": \"经皮肝穿刺胆管造影\",\n" +
                "      \"detailName\": \"经皮肝穿刺胆管造影\",\n" +
                "      \"name\": \"经皮肝穿刺胆管造影\",\n" +
                "      \"dateValue\": \"2020-12-24 17:33:52\",\n" +
                "      \"time\": \"2020-12-24 17:33:52\",\n" +
                "      \"check\": true\n" +
                "    }\n" +
                "  ],\n" +
                "  \"diagOrder\": [],\n" +
                "  \"drugOrder\": [\n" +
                "    {\n" +
                "      \"uniqueName\": \"利多卡因\",\n" +
                "      \"detailName\": \"利多卡因\",\n" +
                "      \"name\": \"利多卡因注射剂\",\n" +
                "      \"flg\": 5,\n" +
                "      \"time\": \"2020-12-24 17:37:27\",\n" +
                "      \"dateValue\": \"2020-12-24 17:37:27\",\n" +
                "      \"selectShow\": false,\n" +
                "      \"check\": true,\n" +
                "      \"form\": \"注射剂\",\n" +
                "      \"selectVal\": \"1\"\n" +
                "    },\n" +
                "    {\n" +
                "      \"uniqueName\": \"青霉素\",\n" +
                "      \"detailName\": \"青霉素\",\n" +
                "      \"name\": \"青霉素注射剂\",\n" +
                "      \"flg\": 5,\n" +
                "      \"time\": \"2020-12-24 17:40:08\",\n" +
                "      \"dateValue\": \"2020-12-24 17:40:08\",\n" +
                "      \"selectShow\": false,\n" +
                "      \"check\": true,\n" +
                "      \"form\": \"注射剂\",\n" +
                "      \"selectVal\": \"1\"\n" +
                "    }\n" +
                "  ],\n" +
                "  \"operationOrder\": [\n" +
                "    {\n" +
                "      \"uniqueName\": \"经皮肝穿刺引流术\",\n" +
                "      \"detailName\": \"经皮肝穿刺引流术\",\n" +
                "      \"name\": \"经皮肝穿刺引流术\",\n" +
                "      \"flg\": 6,\n" +
                "      \"time\": \"2020-12-24 17:39:20\",\n" +
                "      \"dateValue\": \"2020-12-24 17:39:20\",\n" +
                "      \"hasTreat\": 1,\n" +
                "      \"check\": true\n" +
                "    }\n" +
                "  ],\n" +
                "  \"otherOrder\": [],\n" +
                "  \"drug\": [],\n" +
                "  \"transfusion\": [],\n" +
                "  \"transfusionOrder\": [],\n" +
                "  \"dept\": [\n" +
                "    {\n" +
                "      \"name\": \"全科\",\n" +
                "      \"uniqueName\": \"全科\"\n" +
                "    }\n" +
                "  ]\n" +
                "}");
        json.put("need_convert", false);
        System.out.println(JSON.toJSONString(json));
    }
}
