package com.qizhen.healsphere.web;

import com.qizhen.healsphere.facade.KgFacade;
import com.qizhen.healsphere.web.dto.NNodeDTO;
import com.qizhen.healsphere.web.dto.NNodeDetailDTO;
import com.qizhen.healsphere.web.dto.NRelationshipDTO;
import com.qizhen.healsphere.web.dto.RespDTO;
import com.qizhen.healsphere.web.param.NKgQuery;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.CacheManager;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.validation.Valid;
import java.util.List;

/**
 * @Description: 朗通知识图谱控制层
 * @author: gaodm
 * @time: 2018/8/30 10:12
 */
@Controller
@RequestMapping("/v1")
@Api(value = "朗通知识图谱API", tags = { "朗通知识图谱API" })
@SuppressWarnings("unchecked")
@Slf4j
public class NKgController {
    private static final String KGTREECACHE = "KgTreeCache";

    @Autowired
    private KgFacade kgFacade;

    @Autowired
    private CacheManager cacheManager;

    @ApiOperation(value = "获取实体", notes = "获取实体")
    @RequestMapping(value = "/node/query", method = RequestMethod.POST)
    @ResponseBody
    public RespDTO<List<NNodeDTO>> query(@RequestBody @Valid NKgQuery kgQuery) {

        return RespDTO.onSuc(null);
    }


    private NNodeDTO node;
    private List<NRelationshipDTO> relationships;

}

