package com.qizhen.healsphere;

import com.qizhen.healsphere.repository.neo4j.entity.BaseEntity;
import com.qizhen.healsphere.service.EntityService;
import com.qizhen.healsphere.service.RelationshipService;
import com.qizhen.healsphere.web.vo.CreateEntityVO;
import com.qizhen.healsphere.web.vo.RelationshipVO;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.*;

/**
 * 是否空腹及归大类
 */
@RunWith(SpringRunner.class)
@ComponentScan(basePackages = {"com.qizhen.healsphere.model", "com.qizhen.healsphere.repository"})
@SpringBootTest
public class SnomedCTFromExcelTest {
    @Autowired
    RelationshipService relationshipService;
    @Autowired
    EntityService entityService;
    private static String urlExcelPath = "C:\\Users\\17664\\Desktop\\data2(1).xlsx";

    @Test
    public void WriteFromExcel() throws Exception {
        getDataFromExecl(0);
    }

    private void getDataFromExecl(int index) throws Exception {
        InputStream fis = new FileInputStream(urlExcelPath);
        Workbook urlWorkbook = WorkbookFactory.create(fis);
        Sheet urlSheet = urlWorkbook.getSheetAt(index);
        List<RelationshipVO> batch = new ArrayList<>();
        for (int rowNum = 0; rowNum <= urlSheet.getLastRowNum(); rowNum++) {
            try {
                Row row = urlSheet.getRow(rowNum);
                RelationshipVO relationshipVO = saveNeo4j(row.getCell(0).getStringCellValue().trim(), row.getCell(1).getStringCellValue().trim(), row.getCell(2).getStringCellValue().trim(), row.getCell(3).getStringCellValue().trim(), row.getCell(4).getStringCellValue().trim());
                batch.add(relationshipVO);
                if (batch.size() >= 100) {
                    relationshipService.createRelationship(batch);
                    batch.clear();
                }

            } catch (Exception e) {
            }
        }
    }

    private RelationshipVO saveNeo4j(String startName, String startLabel, String relationShip, String endName, String endLabel) throws Exception {
        try {
            if(StringUtils.isEmpty(startName) || StringUtils.isEmpty(startLabel)|| StringUtils.isEmpty(relationShip)|| StringUtils.isEmpty(endName) || StringUtils.isEmpty(endLabel)){
                return null;
            }
            long currentTimeMillis = System.currentTimeMillis();
            BaseEntity startEntity = createNoExists(startLabel, startName);
            System.out.println(System.currentTimeMillis()-currentTimeMillis);
            long startId = startEntity.getId();
            BaseEntity endEntity = createNoExists(endLabel, endName);
            System.out.println(System.currentTimeMillis()-currentTimeMillis);
            Long endId = endEntity.getId();
            RelationshipVO relationshipVO = new RelationshipVO();
            relationshipVO.setStartId(startId);
            relationshipVO.setEndId(endId);
            relationshipVO.setStartLabel(startLabel);
            relationshipVO.setEndLabel(endLabel);
            relationshipVO.setRelationshipType(relationShip);
            return relationshipVO;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    private BaseEntity createNoExists(String labelName, String name) {
        BaseEntity nodeByName = entityService.findNodeByName(labelName, name);
        if (Objects.nonNull(nodeByName)) {//节点不存在
            return nodeByName;
        }
        CreateEntityVO createEntity = new CreateEntityVO();
        createEntity.setName(name);
        createEntity.setLabel(labelName);
        createEntity.getProperty().put("version", "SNOMED_CT");
        return entityService.create(createEntity);
    }

}

